# -*- encoding: utf-8 -*-
##############################################################################
#
#    Avanzosc - Avanced Open Source Consulting
#    Copyright (C) 2011 - 2012 Avanzosc <http://www.avanzosc.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from tools.translate import _
    
    
class sale_order(osv.osv):
    _description = "Reasign taxes on sale order lines"
    _inherit = 'sale.order'
    
    def onchange_partner_id(self, cr, uid, ids, part):
        val = super(sale_order, self).onchange_partner_id(cr, uid, ids, part)
        partner = self.pool.get('res.partner').browse(cr, uid, part)
        values = val['value']
        for order in self.browse(cr, uid, ids):

            fiscal_position = partner.property_account_position.id or False
            self.onchange_pricelist_id(cr, uid, ids, partner.property_product_pricelist.id, fiscal_position, partner)
        return val

    def onchange_pricelist_id(self, cr, uid, ids, pricelist_id, fiscal_position=False, partner_id=False):
        sale_order_lines = self.pool.get('sale.order.line')      
        
        for order in self.browse(cr, uid, ids):
            
            if not fiscal_position:
                fiscal_position = order.partner_id.property_account_position and order.partner_id.property_account_position.id or False
            if not partner_id:
                partner_id = order.partner_id
            for line in order.order_line:
                result = sale_order_lines.product_id_change(cr, uid, line.id, pricelist_id, line.product_id.id, line.product_uom_qty, line.product_uom.id, line.product_uos_qty, line.product_uos.id, line.name, partner_id.id, partner_id.lang, True, order.date_order, line.product_packaging, fiscal_position, False)
                values_line = result['value']
                if fiscal_position:                    
                    taxes_line = values_line['tax_id']
                    values_line['tax_id'] = [(6, 0, taxes_line)]
                sale_order_lines.write(cr, uid, line.id, values_line)

        return {'value': {'pricelist_id': pricelist_id}}
    
sale_order()
    
